@echo off
rem Usage:   AddUsbDrivers.bat WinDir DriverDir EditionIndex OsType
rem Example: AddUsbDrivers.bat C:\WinCopyDir C:\mydrivers 4 1
rem OsType:  0 for x86, 1 for amd64

set MOUNT_DIR=C:\MountWim
set IMAGE_DIR=%~1\sources
set DRIVER_DIR=%~2
set EDITION_INDEX=%3
set OS_TYPE=%4
set ISX86=0
if %OS_TYPE% == 0 (
	set ISX86=1
)
set DISABLE_LINT_FILE=%~dp0LInt_disable.reg

goto test_chkunmount
IF NOT EXIST "%MOUNT_DIR%" (
	md "%MOUNT_DIR%"
) ELSE (
	dir /b /a "%MOUNT_DIR%\*" | >nul findstr "^" && (set UNMOUNT_FIRST=1) || (set UNMOUNT_FIRST=0)
	IF %UNMOUNT_FIRST% neq 0
		dism /unmount-wim /mountdir:"%MOUNT_DIR%" /discard
)
:test_chkunmount
IF NOT EXIST "%MOUNT_DIR%" (
	md "%MOUNT_DIR%"
) ELSE (
	dism /unmount-wim /mountdir:"%MOUNT_DIR%" /discard
)

rem === Mount install.wim image and add USB3.0 drivers.
dism /mount-wim /wimfile:"%IMAGE_DIR%\install.wim" /index:%EDITION_INDEX% /mountdir:"%MOUNT_DIR%"
rem === If dism return error 0xc1510113, use index 1 instead.
rem if %errorlevel% equ -1051655917 (
if %errorlevel% neq 0 (
	dism /mount-wim /wimfile:"%IMAGE_DIR%\install.wim" /index:1 /mountdir:"%MOUNT_DIR%"
)

dism /add-driver /image:"%MOUNT_DIR%" /driver:"%DRIVER_DIR%" /recurse
dism /unmount-wim /mountdir:"%MOUNT_DIR%" /commit

rem === Mount boot.wim image and add USB3.0 drivers. Furthermore, disabling Line-based Interrupts for x86 OS.
dism /mount-wim /wimfile:"%IMAGE_DIR%\boot.wim" /index:1 /mountdir:"%MOUNT_DIR%"
dism /add-driver /image:"%MOUNT_DIR%" /driver:"%DRIVER_DIR%" /recurse
if %ISX86% == 1 (
	reg.exe load HKU\TempHive "%MOUNT_DIR%\Windows\System32\config\SYSTEM"
	reg.exe import "%DISABLE_LINT_FILE%"
	reg.exe unload HKU\TempHive
)
dism /unmount-wim /mountdir:"%MOUNT_DIR%" /commit
dism /mount-wim /wimfile:"%IMAGE_DIR%\boot.wim" /index:2 /mountdir:"%MOUNT_DIR%"
dism /add-driver /image:"%MOUNT_DIR%" /driver:"%DRIVER_DIR%" /recurse
if %ISX86% == 1 (
	reg.exe load HKU\TempHive "%MOUNT_DIR%\Windows\System32\config\SYSTEM"
	reg.exe import "%DISABLE_LINT_FILE%"
	reg.exe unload HKU\TempHive
)
dism /unmount-wim /mountdir:"%MOUNT_DIR%" /commit

rmdir /s /q "%MOUNT_DIR%"